using System.Text.Json.Serialization;
using Luski.net.JsonTypes.BaseTypes;

namespace Luski.net.JsonTypes;

public class OfflineData : IncomingHTTP
{
    [JsonPropertyName("data")]
    [JsonInclude]
    public string[]? Data { get; internal set; } = default!;
}

[JsonSerializable(typeof(OfflineData))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class OfflineDataContext : JsonSerializerContext
{

}