﻿using System;
using Luski.net.Interfaces;
using Luski.net.JsonTypes.BaseTypes;
using System.Collections.Generic;
using System.Linq;
using System.Text.Json.Serialization;
using System.Text.Json.Serialization.Metadata;
using System.Threading;
using System.Threading.Tasks;
using JacobTechEncryption;
using Luski.net.Enums;
using Luski.net.Enums.Main;
using Luski.net.Structures.Main;

namespace Luski.net.Structures.Public;

public class PublicSocketAppUser : PublicSocketUserBase, IAppUser
{
    [JsonPropertyName("selected_channel")]
    [JsonInclude]
    public long SelectedChannel { get; internal set; } = default!;
    [JsonPropertyName("username")]
    [JsonInclude]
    public string Username { get; internal set; } = default!;
}

[JsonSerializable(typeof(PublicSocketAppUser))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class PublicSocketAppUserContext : JsonSerializerContext
{

}
